{
TWMISQL  Component Version 2.0b - Suite GLibWMI 
Copyright () 2009-2013,  by Germn Estvez (Neftal) 
 
  Componente para acceder de forma genrica a las propiedades de WMI.
  Component for access to WMI properties (all components).

Utilizacin/Usage:
  Basta con "soltar" el componente y activarlo.
  Rellenar la clase WMI y la condicion WHERE (o la sentencia SQL)

  Place the component in the form and active it.
  Fill the class and WHERE properties (or the SQL)


========================================================================= 
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones, 
  errores y/o cualquier otro tipo de sugerencia envame un mail a: 
  german_ral@hotmail.com 
 
IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements, 
errors and/or any another type of suggestion send a mail to: 
german_ral@hotmail.com 
========================================================================= 
 
@author Germn Estvez (Neftal) 
@web  http://neftali.clubDelphi.com  
@cat Package GLibWMI 
} 
unit CWMISQL;
 
{ 
========================================================================= 
 
  CWMISQL.pas
 
  Componente 
 
======================================================================== 
  Historia de las Versiones 
------------------------------------------------------------------------ 
 
  14/04/2010    * Creacin.
 
========================================================================= 
 
  Errores detectados no corregidos 
 
========================================================================= 
} 
 
//========================================================================= 
//
// I N T E R F A C E
//
//=========================================================================
interface
 
uses 
  {$IF CompilerVersion >= 16.0}
  VCL.Controls, System.Classes,
  {$ELSE}
  Classes, Controls,
  {$IFEND}
  CWMIBase;
 
type 

  //: Implementacin para el acceso va WMI a la clase Win32_Environment
  TWMISQL = class(TWMIBase)
  private
    fConnected:boolean;
    FWMIClassName: string;
    FSQL: string;
    FClassName: string;
    FProperties: TStrings;

    function GetWMIClass: string;
    procedure SetProperties(const Value: TStrings);

  protected
    //: Rellenar las propiedades.
    procedure FillProperties(AIndex:integer); override;
    // propiedad Active
    procedure SetActive(const Value: Boolean); override;
    //: SQL Para acceder a la informacin de WMI
    function GetWMISQL():string; override;
    //: Obtener el root.
    function GetWMIRoot():string; override;
    //: Limpiar las propiedades
    procedure ClearProps(); override;
  public
    // redefinido el constructor
    constructor Create(AOwner: TComponent); override;
    //: destructor
    destructor Destroy; override;
  published
    //: Propiedades devueltas por la consulta para el objeto actual.
    property Properties:TStrings{TStringList} read FProperties write SetProperties;
    //: Propiedad con la SQL del componente.
    property SQL:string read FSQL write FSQL;

  end;


    
//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

uses
  {$IF CompilerVersion >= 16.0}
  VCL.Forms, WinAPI.Windows, System.Types, VCL.Dialogs, System.SysUtils,
  {$ELSE}
  Forms, Types, Windows, SysUtils, Dialogs,
  {$IFEND}
  UProcedures, UConstantes;


{ TWMISQL }
{-------------------------------------------------------------------------------}

//: SQL Para acceder a la informacin de WMI.
function TWMISQL.GetWMISQL():string;
begin
  Result := FSQL;
end;


// Limpiar las propiedades.
procedure TWMISQL.ClearProps();
begin

  // Limpiar las propiedades
  Self.FProperties.Clear;

end;
//: Constructor del componente 
constructor TWMISQL.Create(AOwner: TComponent);
begin
  inherited;

  // Crear la lista de propiedades
  Self.FProperties := TStringList.Create();

  // Accesoa la documentacin
  Self.MSDNHelp := 'http://msdn.microsoft.com/en-us/library/aa394554(VS.85).aspx';
end;

// destructor del componente
destructor TWMISQL.Destroy();
begin

  // liberar
  Self.FProperties.Free; 
 
  inherited; 
end; 
 
// Obtener la clase 
function TWMISQL.GetWMIClass(): string;
begin
  Result := Self.FSQL;
end;
 
// Obtener Root 
function TWMISQL.GetWMIRoot(): string;
begin 
  Result := STR_CIM2_ROOT; 
end; 
 
// Active 
procedure TWMISQL.SetActive(const Value: Boolean);
begin 
  // mtodo heredado 
  inherited; 
end; 
//: Rellenar las propiedades del componente.
procedure TWMISQL.FillProperties(AIndex: integer);
var
  TS:TStrings;
begin

  // Llamar al heredado (importante)
  inherited;

  TS := TStringList.Create();
  try
    TS.Text := Self.AllProperties[AIndex - 1];

    // Rellenar propiedades...
    ExtractAllProperties(TS, Self.FProperties);
  finally
    TS.Free;
  end;
end;



procedure TWMISQL.SetProperties(const Value: TStrings);
begin
  // Nada
end;

end.
