{ 
TTimeZoneInfo  Component Version 1.9b - Suite GLib 
Copyright () 2009,  by Germn Estvez (Neftal) 
 
  La clase WMI Win32_TimeZone representa la informacin de zona horaria para un ordenador con Windows, que incluye los cambios necesarios para realizar la transicin entre cambios horarios.
 
Utilizacin/Usage: 
  Basta con "soltar" el componente y activarlo. 
 
  Place the component in the form and active it. 
 
  MSDN Info: 
  http://msdn.microsoft.com/en-us/library/aa394498(v=vs.85).aspx 
 
========================================================================= 
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones, 
  errores y/o cualquier otro tipo de sugerencia envame un mail a: 
  german_ral@hotmail.com 
 
IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements, 
errors and/or any another type of suggestion send a mail to: 
german_ral@hotmail.com 
========================================================================= 
 
@author Germn Estvez (Neftal) 
@web  http://neftali.clubDelphi.com   -  http://neftali-mirror.site11.com/
@cat Package GLib 
} 
unit CTimeZoneInfo; 
 
{ 
========================================================================= 
 
  TTimeZoneInfo.pas 
 
  Componente 
 
======================================================================== 
  Historia de las Versiones 
------------------------------------------------------------------------ 
 
  30/04/2013    * Creacin. 
 
========================================================================= 
 
  Errores detectados no corregidos 
 
========================================================================= 
} 
 
//========================================================================= 
// 
// I N T E R F A C E 
// 
//========================================================================= 
interface 
 
uses 
  Classes, Controls, CWMIBase; 
 
type 
  //: Clase para definir las propiedades del componente.
  TTimeZoneProperties = class(TPersistent)
  private
    FBias:sint32;
    FCaption:string;
    FDaylightBias:sint32;
    FDaylightDay:Longword;
    FDaylightDayOfWeek:byte;
    FDaylightDayOfWeekAsString:string;
    FDaylightHour:Longword;
    FDaylightMillisecond:Longword;
    FDaylightMinute:Longword;
    FDaylightMonth:Longword;
    FDaylightMonthAsString:string;
    FDaylightName:string;
    FDaylightSecond:Longword;
    FDaylightYear:Longword;
    FDescription:string;
    FSettingID:string;
    FStandardBias:Longword;
    FStandardDay:Longword;
    FStandardDayOfWeek:byte;
    FStandardDayOfWeekAsString:string;
    FStandardHour:Longword;
    FStandardMillisecond:Longword;
    FStandardMinute:Longword;
    FStandardMonth:Longword;
    FStandardMonthAsString:string;
    FStandardName:string;
    FStandardSecond:Longword;
    FStandardYear:Longword;
  private
  public

// {GET_ENUM}

  published
    property Bias:sint32 read FBias write FBias stored False;
    property Caption:string read FCaption write FCaption stored False;
    property DaylightBias:sint32 read FDaylightBias write FDaylightBias stored False;
    property DaylightDay:Longword read FDaylightDay write FDaylightDay stored False;
    property DaylightDayOfWeek:byte read FDaylightDayOfWeek write FDaylightDayOfWeek stored False;
    property DaylightDayOfWeekAsString:string read GetDaylightDayOfWeekAsString  write FDaylightDayOfWeekAsString stored False;
    property DaylightHour:Longword read FDaylightHour write FDaylightHour stored False;
    property DaylightMillisecond:Longword read FDaylightMillisecond write FDaylightMillisecond stored False;
    property DaylightMinute:Longword read FDaylightMinute write FDaylightMinute stored False;
    property DaylightMonth:Longword read FDaylightMonth write FDaylightMonth stored False;
    property DaylightMonthAsString:string read GetDaylightMonthAsString  write FDaylightMonthAsString stored False;
    property DaylightName:string read FDaylightName write FDaylightName stored False;
    property DaylightSecond:Longword read FDaylightSecond write FDaylightSecond stored False;
    property DaylightYear:Longword read FDaylightYear write FDaylightYear stored False;
    property Description:string read FDescription write FDescription stored False;
    property SettingID:string read FSettingID write FSettingID stored False;
    property StandardBias:Longword read FStandardBias write FStandardBias stored False;
    property StandardDay:Longword read FStandardDay write FStandardDay stored False;
    property StandardDayOfWeek:byte read FStandardDayOfWeek write FStandardDayOfWeek stored False;
    property StandardDayOfWeekAsString:string read GetStandardDayOfWeekAsString  write FStandardDayOfWeekAsString stored False;
    property StandardHour:Longword read FStandardHour write FStandardHour stored False;
    property StandardMillisecond:Longword read FStandardMillisecond write FStandardMillisecond stored False;
    property StandardMinute:Longword read FStandardMinute write FStandardMinute stored False;
    property StandardMonth:Longword read FStandardMonth write FStandardMonth stored False;
    property StandardMonthAsString:string read GetStandardMonthAsString  write FStandardMonthAsString stored False;
    property StandardName:string read FStandardName write FStandardName stored False;
    property StandardSecond:Longword read FStandardSecond write FStandardSecond stored False;
    property StandardYear:Longword read FStandardYear write FStandardYear stored False;
  end;
  
  //: Implementacin para el acceso va WMI a la clase Win32_TimeZone
  TTimeZoneInfo = class(TWMIBase)
  private
    fConnected:boolean;
    FTimeZoneProperties: TTimeZoneProperties;
  protected
    //: Rellenar las propiedades.
    procedure FillProperties(AIndex:integer); override;
    // propiedad Active
    procedure SetActive(const Value: Boolean); override;
    //: Clase para el componente.
    function GetWMIClass():string; override;
    //: Obtener el root.
    function GetWMIRoot():string; override;
    //: Limpiar las propiedades
    procedure ClearProps(); override;
  public
    // redefinido el constructor
    constructor Create(AOwner: TComponent); override;
    //: destructor
    destructor Destroy; override;
  published
    // propiedades de la TimeZone
    property TimeZoneProperties:TTimeZoneProperties read FTimeZoneProperties write FTimeZoneProperties;
  end;

// {CONST_ENUM}

    
//========================================================================= 
// 
// I M P L E M E N T A T I O N 
// 
//========================================================================= 
implementation 
  
uses 
  {Generales} Forms, Types, Windows, SysUtils, 
  {GLib} UProcedures, UConstantes, Dialogs; 
 
  
{ TTimeZone } 
{-------------------------------------------------------------------------------} 
// Limpiar las propiedades
procedure TTimeZoneInfo.ClearProps;
begin

  inherited;

  Self.TimeZoneProperties.FBias := <Tipo sint32 no definido>;
  Self.TimeZoneProperties.FCaption := STR_EMPTY;
  Self.TimeZoneProperties.FDaylightBias := <Tipo sint32 no definido>;
  Self.TimeZoneProperties.FDaylightDay := 0;
  Self.TimeZoneProperties.FDaylightDayOfWeek := 0;
  Self.TimeZoneProperties.FDaylightHour := 0;
  Self.TimeZoneProperties.FDaylightMillisecond := 0;
  Self.TimeZoneProperties.FDaylightMinute := 0;
  Self.TimeZoneProperties.FDaylightMonth := 0;
  Self.TimeZoneProperties.FDaylightName := STR_EMPTY;
  Self.TimeZoneProperties.FDaylightSecond := 0;
  Self.TimeZoneProperties.FDaylightYear := 0;
  Self.TimeZoneProperties.FDescription := STR_EMPTY;
  Self.TimeZoneProperties.FSettingID := STR_EMPTY;
  Self.TimeZoneProperties.FStandardBias := 0;
  Self.TimeZoneProperties.FStandardDay := 0;
  Self.TimeZoneProperties.FStandardDayOfWeek := 0;
  Self.TimeZoneProperties.FStandardHour := 0;
  Self.TimeZoneProperties.FStandardMillisecond := 0;
  Self.TimeZoneProperties.FStandardMinute := 0;
  Self.TimeZoneProperties.FStandardMonth := 0;
  Self.TimeZoneProperties.FStandardName := STR_EMPTY;
  Self.TimeZoneProperties.FStandardSecond := 0;
  Self.TimeZoneProperties.FStandardYear := 0;

end;
//: Constructor del componente 
constructor TTimeZoneInfo.Create(AOwner: TComponent); 
begin 
  inherited; 
 
  Self.FTimeZoneProperties := TTimeZoneProperties.Create(); 
  Self.MSDNHelp := 'http://msdn.microsoft.com/en-us/library/aa394498(v=vs.85).aspx';
end; 
 
// destructor del componente 
destructor TTimeZoneInfo.Destroy(); 
begin 
 
  // liberar 
  FreeAndNil(Self.FTimeZoneProperties); 
 
  inherited; 
end; 
 
// Obtener la clase 
function TTimeZoneInfo.GetWMIClass(): string; 
begin 
  Result := 'Win32_TimeZone'
end; 
 
// Obtener Root 
function TTimeZoneInfo.GetWMIRoot(): string; 
begin 
  Result := STR_CIM2_ROOT; 
end; 
 
// Active 
procedure TTimeZoneInfo.SetActive(const Value: Boolean); 
begin 
  // mtodo heredado 
  inherited; 
end; 
  
//: Recuperar la propiedad  <StandardMonthAsString>
function TTimeZoneInfo.GetStandardMonthAsString():string;
begin 
  Result := 'Not implemented yet';
end;
  
//: Rellenar las propiedades del componente.
procedure TTimeZoneInfo.FillProperties(AIndex: integer);
var
  s:string;
  i:Integer;
  d:TDateTime;
  v:variant;
  vType:TWMIGenericPropType;
  vArr:TArrVariant;
  vNull:boolean;
  vp:TTimeZoneProperties;
begin

  // Llamar al heredado (importante)
  inherited;

  // Rellenar propiedades...
  vp := Self.TimeZoneProperties;

  GetWMIPropertyValue(Self, 'Bias', v, vNull);
   ==> Tipo: sint32 no definido en <_GeneraFillProps>

  GetWMIPropertyValue(Self, 'Caption', v, vNull);
  vp.FCaption := VariantStrValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightBias', v, vNull);
   ==> Tipo: sint32 no definido en <_GeneraFillProps>

  GetWMIPropertyValue(Self, 'DaylightDay', v, vNull);
  vp.FDaylightDay := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightDayOfWeek', v, vNull);
  vp.FDaylightDayOfWeek := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightHour', v, vNull);
  vp.FDaylightHour := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightMillisecond', v, vNull);
  vp.FDaylightMillisecond := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightMinute', v, vNull);
  vp.FDaylightMinute := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightMonth', v, vNull);
  vp.FDaylightMonth := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightName', v, vNull);
  vp.FDaylightName := VariantStrValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightSecond', v, vNull);
  vp.FDaylightSecond := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'DaylightYear', v, vNull);
  vp.FDaylightYear := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'Description', v, vNull);
  vp.FDescription := VariantStrValue(v, vNull);

  GetWMIPropertyValue(Self, 'SettingID', v, vNull);
  vp.FSettingID := VariantStrValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardBias', v, vNull);
  vp.FStandardBias := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardDay', v, vNull);
  vp.FStandardDay := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardDayOfWeek', v, vNull);
  vp.FStandardDayOfWeek := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardHour', v, vNull);
  vp.FStandardHour := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardMillisecond', v, vNull);
  vp.FStandardMillisecond := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardMinute', v, vNull);
  vp.FStandardMinute := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardMonth', v, vNull);
  vp.FStandardMonth := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardName', v, vNull);
  vp.FStandardName := VariantStrValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardSecond', v, vNull);
  vp.FStandardSecond := VariantIntegerValue(v, vNull);

  GetWMIPropertyValue(Self, 'StandardYear', v, vNull);
  vp.FStandardYear := VariantIntegerValue(v, vNull);

end;

// {IMPL_ENUM}

end.
